use ExtUtils::MakeMaker;

require 5.6.0; # Check for perl 5.6.0 or higher
print "Good, you have a recent enough perl version!\n";

check_for_flex();

$BYACC = "(cd dpl; yapp -o grammar.pm -m 'dpl::grammar' grammar.yp)";

print "Doing pre-compilation...\n"; `$BYACC`;


WriteMakefile(
	      'NAME'		=> 'dpl',
	      'VERSION_FROM'	=> 'dpl.pm',
	      'PREREQ_PM'	=> {
		  'Parse::Yapp::Driver' => 1.03,
		  'Storable' => 1.0.12,
	      },
	      'LIBS'		=> ['-lfl'],
	      'DEFINE'		=> '',
	      'INC'		=> '',
	      'MYEXTLIB'        => 'lib.so',
	     );

sub MY::postamble {
  "
\$(MYEXTLIB): lex.p.c dpl.pm
	\$(CC) -c lex.p.c
	\$(AR) cr \$(MYEXTLIB) lex.p.o
	ranlib \$(MYEXTLIB)

dpl/grammar.pm: dpl/grammar.yp
	$BYACC

lex.p.c: lexer.lex
	flex -Pp lexer.lex
           ";
}

sub check_for_flex {
  print "Checking for flex...";
  chomp($whereis = `whereis flex`);
  if ($whereis eq "flex:") {
    print " no\n";
    die ("Can't find GNU flex... get it from ftp://ftp.gnu.org");
  }
  print "yes\n";

  # Check for flex -Pp option
  print "Checking for flex -P option...";
  `cd /tmp;echo -e '%%\n a ; \n %%\n' | flex -Pp`;
  unless (-e "/tmp/lex.p.c") {
    print " no\n";
    die ("Get latest version for flex");
  }
  print "yes\n";
}
