%{
 #define YY_DECL char* yylex() void;
%}

%{
#define set_scan(x) BEGIN (_stack[_i]=x)
#define push_to(x) _stack[++_i]=YY_START; set_scan(x)
#define pop_back set_scan(_stack[--_i])
int _stack[20];
int _i= 0;
int _ccha= 0;
%}

%option yylineno

    char buffer[15];
    int comment_state = 0;

SPACE       (" "|\t|\n|\r)
OPEN_META   (\<{SPACE}*[mM][eE][tT][aA]{SPACE}*\>)
CLOSE_META  (\<\/{SPACE}*[Mm][Ee][Tt][Aa]{SPACE}*\>)
OPEN_PERL   (\<{SPACE}*[Pp][Ee][Rr][Ll]{SPACE}*\>)
CLOSE_PERL  (\<\/{SPACE}*[Pp][Ee][Rr][Ll]{SPACE}*\>)
OPEN_DICT   (\<{SPACE}*[Dd][Ii][Cc][Tt]{SPACE}*\>)
CLOSE_DICT  (\<\/{SPACE}*[Dd][Ii][Cc][Tt]{SPACE}*\>)

%x PERL COMMENT DPL META quoteid

%%
<INITIAL,DPL,META>{SPACE}+           ;


^{OPEN_META}                    { /* Start a META block */ 
                                  BEGIN(META); 
                                  return strcpy(buffer,"PLEX_META_INIT\0"); }
<META>^{CLOSE_META}             { /* End a META block */ 
                                  BEGIN(0);
                                  return strcpy(buffer,"PLEX_META_END\0"); }

^{OPEN_DICT}                   { /* Start a DPL block */
                                  BEGIN(DPL); 
				  return strcpy(buffer,"PLEX_DPL_INIT\0");}
<DPL>^{CLOSE_DICT}             { /* End a DPL block */
                                  BEGIN(0); return strcpy(buffer,"PLEX_DPL_END\0");}





^{OPEN_PERL}                    { /* Start a Perl block */
                                  BEGIN(PERL); return strcpy(buffer,"PLEX_PERL_INIT\0");}
<PERL>^{CLOSE_PERL}             { /* End a Perl block */
                                  BEGIN(0); return strcpy(buffer,"PLEX_PERL_END\0");}

<PERL>\n/{CLOSE_PERL}           { /* Return all the Perl code... */
                                  return strcpy(buffer,"PLEX_PERL\0");}
<PERL>.*                        { /* Eat all perl lines saving them */ yymore();}
<PERL>\n                        { /* Eat all  new lines saving them */ yymore();}





<DPL,META>\"(\\\"|[^\"])*\"       {return strcpy(buffer,"PLEX_STR\0");}

<DPL,META>#           {/* Eat Comments */ 
                       comment_state = YY_START;
                       BEGIN(COMMENT);}
<COMMENT>.*           ;
<COMMENT>\n           {BEGIN(comment_state); comment_state=0;}

<DPL,META>\/\{        { push_to(quoteid); yymore(); _ccha = 1;}
<quoteid>\}           { yymore();
                        if(--_ccha == 0) { pop_back;
                                           return strcpy(buffer,"PLEX_STR\0");}
                      }

<quoteid>\{           { ++ _ccha; yymore() ;      }
<quoteid>.|\n         { yymore() ;      }
                       

<DPL,META>begin            {return strcpy(buffer,"PLEX_BEGIN\0");}

<DPL,META>end              {return strcpy(buffer,"PLEX_END\0");}

<DPL,META>[-@?`'',._!A-Za-z0-9*]+ {return strcpy(buffer,"PLEX_ID\0");}

<DPL,META>.                {return strcpy(buffer,yytext);}
 
<<EOF>>               {return strcpy(buffer,"\0");}

.                     ; /* anything else, eat! */
%%
int pwrap(void) {
  return 1;
}
int plexlineno(void) {
    return plineno;
}
char* plextext(void) {
    return ptext;
}
int plexinit(char* file) {
  yyin = fopen(file,"r");
  return (yyin?1:0);
}
