package dpl::tex;

use dpl;
use Data::Dumper;

$VERSION = 0.02;

our $met;

sub mkdicttex {
  my $filename= shift;
  my $outfilename= shift;

  my $d1 = dpl::opendb($filename);

  open(G,"sort -d -f $filename.wrdlst|") or die("cant open $filename\n");
  open(O,"> $outfilename") or die("cant create $outfilename\n");

  $met = $d1->{meta};
  my $intr = $met->{introduction}{ex};
  $intr =~ s{</?p>}{\n}g;
  my $agr = $d1->{h}{'!agradecimentos'}[0]{sem};

  print O "
\\documentclass[10pt,twocolumn]{book}
\\usepackage[portuges]{babel}
\\usepackage[isolatin]{inputenc}

$met->{latex}{package}

\\usepackage{dict}
\\makeindex
\\begin{document}
\\title{$met->{'title'}}
\\author{",((ref($met->{author}) eq "HASH")?
	    $met->{author}{name}:
	    join(" \\and ",map { $_->{name} } @{$met->{author}})),
	      "}
\\maketitle
$intr
\\section*{Estrutura das entradas}
",
any2tex( $met->{"skell"}, 0),

"\n \\section*{Lista de colaboradores}
",
join(";\n",@$agr),

"
\\newpage
\\parskip 0pt

\\begin{dictionary}
"; 

  $fl="";
  while(<G>){
      chomp();
      next if /^!/;
      if(/([a-zA-Z])/ and $fl ne n($1)){$fl = n($1);
					       print O "\\bigletter{$fl}\n";}
      print O "\\term{",any2tex($_),"}{", 
          join("\n\\hspace{-2mm}- ", map{any2tex($_)} @{$d1->{h}{$_}}) ,"}\n";
  }

  print O "\\end{dictionary}
         \\end{document}";

}

sub any2tex {
   my ($r,$i)= @_;
   my $ind = ($i >= 0)? (" " x $i) : "";
   if (ref($r) eq "HASH" )
      {if (%$r){ 
         "\\begin{description}". hash2tex($r,abs($i)+3) . "\\end{description}" }
       else {""}
      }
   elsif (ref($r) eq "ARRAY")
      { if (@$r){ "\\begin{itemize}\n\\item " . 
          join("\n\\item", map (any2tex($_,abs($i)+3), @$r)) . 
          "\n\\end{itemize}\n" }
       else {""}
      }
   else {
      $r =~ s/_/\\_/g; 
      $r =~ s!\|!\/!g; 
      $r =~ s/<p>/\n\n/g; 
      $r =~ s/<b>/\\textbf{/g; 
      $r =~ s!</b>!}!g; 
      $r =~ s/~/\\~{ }/g; 
        "$ind$r"
      #  "$r"
   }
}

sub hash2tex {
  my($r,$i)=($_[0],$_[1]);
  my $c="";
  my $a;

  # Queremos que a semantica seja sempre a primeira a aparecer
  if (exists($r->{sem})) {
    $c .= "\n\\item[]\\hspace{-2mm}" . any2tex($r->{sem},-1)
  }

  for $a (keys %$r) {
    next if($a eq "sem");
    if($a eq "syn"){
      my $s = (defined($met->{descs}{$a}))?"$met->{descs}{$a}:":"sin.:";
      $c .= "\n\\item[]\\hspace{-2mm}\\emph{". any2tex($s,-$i). "} " .
	join("; ",( map {any2tex($_,-1)} @{$r->{$a}}));
    }
    else{
      # Este $aa  usado para pesquisa no array associativo de descricoes;
      my $aa = ($a=~/^\!/)?$':$a;
      my $s = (defined($met->{descs}{$aa}))?"$met->{descs}{$aa}:":"$a:";
      $c .= "\n\\item[]\\hspace{-2mm}\\emph{". any2tex($s,-$i). "} " .
	any2tex($r->{$a},-$i);
    }
  }
  $c;
}

sub n {
  my $a = uc(shift);
  for ($a) {
    tr//A/;
    tr//A/;
    tr//E/;
    tr//E/;
    tr//I/;
    tr//I/;
    tr//O/;
    tr//O/;
    tr//U/;
    tr//U/;
    tr//C/;
  }
  return $a;
}


1;
__END__
